randomtest 3.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120
  1. #!/bin/sh
  2. # If not specified in environment...
  3. if ! test "$LIBC"; then
  4. # Select which libc to build against
  5. LIBC="glibc"
  6. LIBC="uclibc"
  7. fi
  8. # x86 32-bit:
  9. #CROSS_COMPILER_PREFIX="i486-linux-uclibc-"
  10. # My system has strange prefix for x86 64-bit uclibc:
  11. #CROSS_COMPILER_PREFIX="x86_64-pc-linux-gnu-"
  12. if test $# -lt 2 || ! test -d "$1" || test -e "$2"; then
  13. echo "Usage: $0 SRC_DIR TMP_DIR"
  14. echo
  15. echo "SRC_DIR will be copied to TMP_DIR directory."
  16. echo "Then a random build will be performed."
  17. echo
  18. echo "Useful variables:"
  19. echo "\$LIBC, \$CROSS_COMPILER_PREFIX, \$MAKEOPTS"
  20. exit 1
  21. fi
  22. cp -dpr -- "$1" "$2" || { echo "copy error"; exit 1; }
  23. cd -- "$2" || { echo "cd $dir error"; exit 1; }
  24. # Generate random config
  25. make randconfig >/dev/null || { echo "randconfig error"; exit 1; }
  26. # Tweak resulting config
  27. cat .config \
  28. | grep -v CONFIG_DEBUG_PESSIMIZE \
  29. | grep -v CONFIG_WERROR \
  30. | grep -v CONFIG_CROSS_COMPILER_PREFIX \
  31. | grep -v CONFIG_SELINUX \
  32. | grep -v CONFIG_EFENCE \
  33. | grep -v CONFIG_DMALLOC \
  34. \
  35. | grep -v CONFIG_RFKILL \
  36. >.config.new
  37. mv .config.new .config
  38. echo '# CONFIG_DEBUG_PESSIMIZE is not set' >>.config
  39. echo '# CONFIG_WERROR is not set' >>.config
  40. echo "CONFIG_CROSS_COMPILER_PREFIX=\"${CROSS_COMPILER_PREFIX}\"" >>.config
  41. echo '# CONFIG_SELINUX is not set' >>.config
  42. echo '# CONFIG_EFENCE is not set' >>.config
  43. echo '# CONFIG_DMALLOC is not set' >>.config
  44. echo '# CONFIG_RFKILL is not set' >>.config
  45. # If glibc, don't build static
  46. if test x"$LIBC" = x"glibc"; then
  47. cat .config \
  48. | grep -v CONFIG_STATIC \
  49. \
  50. | grep -v CONFIG_FEATURE_2_4_MODULES \
  51. | grep -v CONFIG_FEATURE_USE_BSS_TAIL \
  52. | grep -v CONFIG_DEBUG_SANITIZE \
  53. >.config.new
  54. mv .config.new .config
  55. echo '# CONFIG_STATIC is not set' >>.config
  56. # newer glibc (at least 2.23) no longer supply query_module() ABI.
  57. # People who target 2.4 kernels would likely use older glibc (and older bbox).
  58. echo '# CONFIG_FEATURE_2_4_MODULES is not set' >>.config
  59. echo '# CONFIG_FEATURE_USE_BSS_TAIL is not set' >>.config
  60. echo '# CONFIG_DEBUG_SANITIZE is not set' >>.config
  61. fi
  62. # If uclibc, build static, and remove some things
  63. # likely to not work on uclibc.
  64. if test x"$LIBC" = x"uclibc"; then
  65. cat .config \
  66. | grep -v CONFIG_STATIC \
  67. | grep -v CONFIG_BUILD_LIBBUSYBOX \
  68. | grep -v CONFIG_PIE \
  69. \
  70. | grep -v CONFIG_FEATURE_2_4_MODULES \
  71. | grep -v CONFIG_FEATURE_SYNC_FANCY \
  72. | grep -v CONFIG_FEATURE_TOUCH_NODEREF \
  73. | grep -v CONFIG_NANDWRITE \
  74. | grep -v CONFIG_NANDDUMP \
  75. | grep -v CONFIG_BLKDISCARD \
  76. | grep -v CONFIG_NSENTER \
  77. | grep -v CONFIG_UNSHARE \
  78. >.config.new
  79. mv .config.new .config
  80. echo 'CONFIG_STATIC=y' >>.config
  81. echo '# CONFIG_BUILD_LIBBUSYBOX is not set' >>.config
  82. echo '# CONFIG_PIE is not set' >>.config
  83. echo '# CONFIG_FEATURE_2_4_MODULES is not set' >>.config
  84. echo '# CONFIG_FEATURE_SYNC_FANCY is not set' >>.config
  85. echo '# CONFIG_FEATURE_TOUCH_NODEREF is not set' >>.config
  86. # My uclibc installation does not support some needed APIs...
  87. echo '# CONFIG_NANDWRITE is not set' >>.config
  88. echo '# CONFIG_NANDDUMP is not set' >>.config
  89. echo '# CONFIG_BLKDISCARD is not set' >>.config
  90. echo '# CONFIG_NSENTER is not set' >>.config
  91. echo '# CONFIG_UNSHARE is not set' >>.config
  92. fi
  93. # If STATIC, remove some things.
  94. # PAM with static linking is probably pointless
  95. # (but I need to try - now I don't have libpam.a on my system, only libpam.so)
  96. if grep -q "^CONFIG_STATIC=y" .config; then
  97. cat .config \
  98. | grep -v CONFIG_PAM \
  99. >.config.new
  100. mv .config.new .config
  101. echo '# CONFIG_PAM is not set' >>.config
  102. fi
  103. # Regenerate .config with default answers for yanked-off options
  104. # (most of default answers are "no").
  105. { yes "" | make oldconfig >/dev/null; } || { echo "oldconfig error"; exit 1; }
  106. # Build!
  107. nice -n 10 make $MAKEOPTS 2>&1 | tee make.log
  108. # Return exitcode 1 if busybox executable does not exist
  109. test -x busybox